package nc.impl.gl.dealQueryData;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import javax.naming.NamingException;
import nc.bs.logging.Logger;
import nc.bs.pub.DataManageObject;
import nc.vo.gl.GBExportVO.CashFlowExpVO;
import nc.vo.gl.GBExportVO.ExportConditionVO;
import nc.vo.pub.lang.UFDouble;

public class GLCashFlowVoucherQueryDMO extends DataManageObject {

   public GLCashFlowVoucherQueryDMO() throws NamingException {
   }

   public List getCashFlowVoucherQueryData(ExportConditionVO conditionVO) throws Exception {
      List cashFlowList = this.getCashFlowCaseExp(new String[]{conditionVO.getPk_glorgbook()}, conditionVO.getYear(), conditionVO.getMonths()[0], conditionVO.getMonths()[conditionVO.getMonths().length - 1]);
      return cashFlowList;
   }

   public List getCashFlowCaseExp(String[] pk_glorgbooks, String strYear, String strBeginPeriod, String strEndPeriod) throws Exception {
      StringBuffer sql = new StringBuffer();
      ArrayList cashFlowList = new ArrayList();
      sql.append("select flag, memo, money, moneymain, pk_cashflow, gl_cashflowcase.pk_currtype, pk_vouchertypev, nov, pk_voucher, gl_cashflowcase.pk_glorgbook ");
      sql.append("from gl_cashflowcase, gl_detail ");
      sql.append(" where gl_cashflowcase.pk_detail = gl_detail.pk_detail");
      sql.append(" and " + this.getInSql("gl_detail", "pk_glorgbook", true, pk_glorgbooks));
      sql.append(" and gl_detail.yearv  =\'" + strYear + "\'");
      sql.append(" and gl_detail.periodv >= \'" + strBeginPeriod + "\'");
      sql.append(" and gl_detail.periodv <= \'" + strEndPeriod + "\'");
      sql.append(" and gl_detail.dr = 0");
      sql.append(" order by pk_voucher");
      Connection con = null;
      Statement stmt = null;
      ResultSet rs = null;

      try {
         con = this.getConnection();
         stmt = con.createStatement();
         rs = stmt.executeQuery(sql.toString());

         while(rs.next()) {
            CashFlowExpVO e = new CashFlowExpVO();
            e.setFlag(Integer.valueOf(rs.getInt("flag")));
            e.setMemo(rs.getString("memo"));
            e.setMoney(new UFDouble(rs.getBigDecimal("money")));
            e.setMoneymain(new UFDouble(rs.getBigDecimal("moneymain")));
            e.setPk_cashflow(rs.getString("pk_cashflow"));
            e.setM_pk_currtype(rs.getString("pk_currtype"));
            e.setPk_vouchertype(rs.getString("pk_vouchertypev"));
            e.setVoucherno(rs.getString("nov"));
            e.setPk_voucher(rs.getString("pk_voucher"));
            e.setPk_glorgbook(rs.getString("pk_glorgbook"));
            cashFlowList.add(e);
         }
      } finally {
         try {
            if(rs != null) {
               rs.close();
            }

            if(stmt != null) {
               stmt.close();
            }
         } catch (Exception var19) {
            Logger.error(var19.getMessage(), var19);
         }

         try {
            if(con != null) {
               con.close();
            }
         } catch (Exception var18) {
            Logger.error(var18.getMessage(), var18);
         }

      }

      return cashFlowList;
   }

   private String getInSql(String p_tableName, String p_fieldName, boolean p_fieldIsStringType, String[] p_fieldValues) {
      StringBuffer childSql = new StringBuffer();
      if(p_fieldValues.length == 0) {
         return " 1=2 ";
      } else {
         int i;
         if(!p_fieldIsStringType) {
            if(p_fieldValues.length == 1) {
               childSql.append(" ").append(p_tableName).append(".").append(p_fieldName).append(" = ").append(p_fieldValues[0]).append(" ");
            } else {
               childSql.append(" (").append(p_tableName).append(".").append(p_fieldName).append(" in (").append(p_fieldValues[0]);

               for(i = 1; i < p_fieldValues.length; ++i) {
                  childSql.append(",").append(p_fieldValues[i]);
               }

               childSql.append(")) ");
            }
         } else if(p_fieldValues.length == 1) {
            childSql.append(" ").append(p_tableName).append(".").append(p_fieldName).append(" = \'").append(p_fieldValues[0]).append("\' ");
         } else {
            childSql.append("(").append(p_tableName).append(".").append(p_fieldName).append(" in (\'").append(p_fieldValues[0]).append("\'");

            for(i = 1; i < p_fieldValues.length; ++i) {
               childSql.append(",\'").append(p_fieldValues[i]).append("\'");
            }

            childSql.append(")) ");
         }

         return childSql.toString();
      }
   }
}
